Buteo::StorageProfile Class Reference

Storage Profile Class. More...

`#include <StorageProfile.h>`

Inheritance diagram for Buteo::StorageProfile:

## Public Member Functions

| StorageProfile (const QString &aName)
| Constructs an empty StorageProfile with the given name.
| StorageProfile (const QDomElement &aRoot)
| Constructs a profile from the given XML.
| StorageProfile (const StorageProfile &aSource)
| Copy constructor.
| ~StorageProfile ()
| Destructor.
virtual StorageProfile * | clone () const
| Creates a clone of the profile.
virtual bool | isEnabled () const
| Returns if the profile is enabled.
Public Member Functions inherited from Buteo::Profile
| Profile ()
| Default Constructor.
| Profile (const QString &aName, const QString &aType)
| Constructs a Profile object with given name and type.
| Profile (const QDomElement &aRoot)
| Constructs a Profile object from XML.
| Profile (const Profile &aSource)
| Copy constructor.
virtual | ~Profile ()
| Destructor.
QString | name () const
| Gets the name of the profile.
QString | displayname () const
| Gets the display name of the profile.
virtual void | setName (const QString &aName)
| Sets the name of the profile.
virtual void | setName (const QStringList &aKeys)
| Sets the name of the profile.
QString | type () const
| Gets the type of the profile.
virtual QDomElement | toXml (QDomDocument &aDoc, bool aLocalOnly=true) const
| Creates a XML representation of the profile.
QString | toString () const
| Outputs a XML representation of the profile to a string.
QString | key (const QString &aName, const QString &aDefault=QString()) const
| Gets the value of the given key.
QMap< QString, QString > | allKeys () const
| Gets all keys and their values.
QMap< QString, QString > | allNonStorageKeys () const
| Gets all keys that are not related to storages.
bool | boolKey (const QString &aName, bool aDefault=false) const
| Gets the value of the given boolean key.
QStringList | keyValues (const QString &aName) const
| Gets the values of all keys with the given name.
QStringList | keyNames () const
| Gets the names of all keys.
void | setKey (const QString &aName, const QString &aValue)
| Sets the value of a key.
void | setKeyValues (const QString &aName, const QStringList &aValues)
| Sets multiple values for a key.
void | setBoolKey (const QString &aName, bool aValue)
| Sets the value of a boolean key.
void | removeKey (const QString &aName)
| Removes a key from profile. All instances of the key are removed.
const ProfileField * | field (const QString &aName) const
| Gets the field with the given name.
QList< const ProfileField * > | allFields () const
| Gets all fields.
QList< const ProfileField * > | visibleFields () const
| Gets all visible fields of the profile.
bool | isValid () const
| Checks if the profile is valid.
QStringList | subProfileNames (const QString &aType="") const
| Gets the names of all sub-profiles with the given type.
Profile * | subProfile (const QString &aName, const QString &aType="")
| Gets a sub-profile with the given name and type.
const Profile * | subProfile (const QString &aName, const QString &aType="") const
| const method for subProfile
const Profile * | subProfileByKeyValue (const QString &aKey, const QString &aValue, const QString &aType, bool aEnabledOnly) const
| Gets a sub-profile by key value.
QList< Profile * > | allSubProfiles ()
| Gets all sub-profiles.
QList< const Profile * > | allSubProfiles () const
| Gets all sub-profiles as const.
void | merge (const Profile &aSource)
| Merges a profile to this profile.
bool | isLoaded () const
| Checks if the profile is fully constructed by loading all sub-profiles from separate profile files.
void | setLoaded (bool aLoaded)
| Sets if the profile is fully loaded.
void | setEnabled (bool aEnabled)
| Set is the profile is enabled.
bool | isHidden () const
| Checks if the profile is hidden.
bool | isProtected () const
| Checks if the profile is protected.

## Additional Inherited Members

Static Public Attributes inherited from Buteo::Profile
static const QString | TYPE_CLIENT
| String constants for different profile type names.
static const QString | TYPE_SERVER
| Server type .
static const QString | TYPE_STORAGE
| Storage type.
static const QString | TYPE_SYNC
| Service type.

## Detailed Description

Storage Profile Class.

## Constructor & Destructor Documentation

## StorageProfile() [1/3]

StorageProfile::StorageProfile | ( | const QString & | aName | ) |

explicit

Constructs an empty StorageProfile with the given name.

Parameters

  aName | Name of the profile to create.

## StorageProfile() [2/3]

StorageProfile::StorageProfile | ( | const QDomElement & | aRoot | ) |

explicit

Constructs a profile from the given XML.

Parameters

  aRoot | Root element of the XML node tree.

## StorageProfile() [3/3]

StorageProfile::StorageProfile | ( | const StorageProfile & | aSource | ) |

Copy constructor.

Parameters

  aSource | Copy source.

## Member Function Documentation

## clone()

StorageProfile * StorageProfile::clone | ( |  | ) | const

virtual

Creates a clone of the profile.

Returns
  The clone.

Reimplemented from Buteo::Profile.

## isEnabled()

bool StorageProfile::isEnabled | ( |  | ) | const

virtual

Returns if the profile is enabled.

Storage profile is disabled by default. This means that if there is no key for the enabled status, the profile will be disabled.

Returns
  Is the profile enabled.

Reimplemented from Buteo::Profile.

The documentation for this class was generated from the following files:

- StorageProfile.h
- StorageProfile.cpp